require "prefabutil"

local Assets =
{
	Asset("ANIM", "anim/gate.zip"),
	Asset("ATLAS", "images/inventoryimages/gate.xml"),
}

local function plant(inst)
	if(table.getn(menu) >= 8) then
		GetPlayer().components.talker:Say("I can't plant any more worms!")
		
		return
	end
	
	inst:RemoveComponent("inventoryitem")
	inst.AnimState:PlayAnimation("idle_planted")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/plant_tree")

	local warpgate = SpawnPrefab("warpgate")

	if warpgate then
		warpgate.Transform:SetPosition(inst.Transform:GetWorldPosition())		
		inst:Remove()
	end
end

local function ondeploy (inst, pt)
	inst.Transform:SetPosition(pt:Get())

	plant(inst)
end

local notags = {'NOBLOCK', 'player', 'FX'}

local function test_ground(inst, pt)
	local tiletype = GetGroundTypeAtPosition(pt)
	local ground_OK = tiletype ~= GROUND.IMPASSABLE and tiletype ~= GROUND.UNDERROCK and tiletype < GROUND.UNDERGROUND
	
	if ground_OK then
		local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4, nil, notags) -- or we could include a flag to the search?
		local min_spacing = inst.components.deployable.min_spacing or 2

		for k, v in pairs(ents) do
			if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
				if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing * min_spacing then
					return false
				end
			end
		end

		return true
	end

	return false
end

local function displaynamefn(inst)
	return "Gate"
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("gate")
	inst.AnimState:SetBuild("gate")
	inst.AnimState:PlayAnimation("idle")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/gate.xml"
	
	inst:AddComponent("deployable")
	inst.components.deployable.test = test_ground
	inst.components.deployable.ondeploy = ondeploy
	
	inst.displaynamefn = displaynamefn

	return inst
end

return Prefab("warpgate/inventory/gate", fn, Assets),
	MakePlacer("warpgate/gate_placer", "teleporter_worm", "teleporter_worm_friendly_build", "idle_loop")