require "prefabutil"
require "warpgate_shared"

local Assets =
{
	Asset("ATLAS", "images/inventoryimages/warpgate_teleporter.xml"),
}


local function displaynamefn(inst)
	return "Warp Gate Teleporter"
end

local function caninteract(inst)
	return true
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	MakeInventoryPhysics(inst)

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/warpgate_teleporter.xml"
		
	inst:AddComponent("useableitem")
    inst.components.useableitem:SetOnUseFn(WarpgateTeleportTo)
	inst.components.useableitem:SetCanInteractFn(caninteract)
	
	inst.displaynamefn = displaynamefn
		
	return inst
end

return Prefab("vermicomposting/inventory/warpgate_teleporter", fn, Assets)